//+------------------------------------------------------------------+
//|                                           VSA TrendDiamonds.mq4 |
//|                                    Copyright  2008, FOREXflash. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, FOREXflash Software Corp."
#property link      "http://www.metaquotes.net"
//----
#property indicator_separate_window
#property indicator_buffers 4

#property indicator_color1 Black
#property indicator_color2 Red
#property indicator_color3 Lime
#property indicator_color4 White

#property indicator_width1 2
#property indicator_width2 2
#property indicator_width3 2
#property indicator_width4 2
#property indicator_minimum 0
#property indicator_maximum 1

extern int timeFrame=0;
extern int period_ma=5;
extern int method_=MODE_SMMA;
extern int price_=PRICE_CLOSE;
extern double step_psar=0.01;
extern double max_psar=0.3;
extern int period_boll=14;
extern int dev_boll=2;
extern int bolldiff=15;
extern bool   alertsOn        = false;
extern bool   alertsOnCurrent = true;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = false;
extern bool   alertsEmail     = false;

//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];

double drawMA,ma0,ma1;
double ca;
double psar;
double boll_upper0,boll_upper1;
double boll_lower0,boll_lower1;
double bollingerdiff0,bollingerdiff1;
double trend[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
int init()
{
   IndicatorBuffers(5);
   SetIndexBuffer(0,ExtMapBuffer4); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,ExtMapBuffer1); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,ExtMapBuffer2); SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(3,ExtMapBuffer3); SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexBuffer(4,trend);
   timeFrame=MathMax(timeFrame,Period());
   return(0);
}
int deinit()
{
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
int start()
  {
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(MathMax(Bars-counted_bars,3*timeFrame/Period()),Bars-1);
 
   for(int i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
      drawMA=iMA(NULL,timeFrame,7,0,MODE_SMA,(High[i]-Low[i])/2,y);
      ma0=iMA(NULL,timeFrame,period_ma,0,method_,price_,y);
      ma1=iMA(NULL,timeFrame,period_ma,0,method_,price_,y+1);
      psar=iSAR(NULL,timeFrame,step_psar,max_psar,y);
      boll_lower0=iBands(NULL,timeFrame,period_boll,dev_boll,0,PRICE_CLOSE,MODE_LOWER,y);
      boll_upper0=iBands(NULL,timeFrame,period_boll,dev_boll,0,PRICE_CLOSE,MODE_UPPER,y);
      bollingerdiff0=(boll_upper0-boll_lower0)/Point;
      boll_lower1=iBands(NULL,timeFrame,period_boll,dev_boll,0,PRICE_CLOSE,MODE_LOWER,y+1);
      boll_upper1=iBands(NULL,timeFrame,period_boll,dev_boll,0,PRICE_CLOSE,MODE_UPPER,y+1);
      bollingerdiff1=(boll_upper1-boll_lower1)/Point; 
   
   
      ExtMapBuffer1[i] = EMPTY_VALUE;
      ExtMapBuffer2[i] = EMPTY_VALUE;
      ExtMapBuffer3[i] = EMPTY_VALUE;
      ExtMapBuffer4[i] = EMPTY_VALUE;
   
      //SELL SIGNAL
      trend[i] = trend[i+1];
      if(ma0<=ma1 && psar>iClose(NULL,timeFrame,y) && bollingerdiff0>bolldiff && bollingerdiff0>bollingerdiff1) { ExtMapBuffer1[i]=1; trend[i] = -1; }
      if(ma0>=ma1 && psar<iClose(NULL,timeFrame,y) && bollingerdiff0>bolldiff && bollingerdiff0>bollingerdiff1) { ExtMapBuffer2[i]=1; trend[i] =  1; }
      if(ExtMapBuffer1[i]==EMPTY_VALUE && ExtMapBuffer2[i]==EMPTY_VALUE)                                        { ExtMapBuffer3[i]=1; trend[i] =  0; }
   }
   manageAlerts();
   return(0);
}

//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      if (trend[whichBar] != trend[whichBar+1]) whichBar=iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
      {
         if (trend[whichBar] ==  1) doAlert(whichBar,"up");
         if (trend[whichBar] == -1) doAlert(whichBar,"down");
      }
   }
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," VSA trend changed to ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol(),"VSA trend diamonds"),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}